#include <Servo.h>
#include <Wire.h> 
#include <LiquidCrystal_I2C.h>

//Addr: 0x3F, 20 chars & 4 lines
LiquidCrystal_I2C lcd(0x27, 2, 1, 0, 4, 5, 6, 7, 3, POSITIVE);

int sdcc = 13;                 // sortie DCC digital pin 13
int potvit;
int potadresse;
int adresse=0;
int ma=1;
int vitesse=0;
int pinretro1=4;
int pinretro2=5;
int pinretro3=6;
int pinretro4=7;
int pinrc=8;
int f0=0;
int f1=0;
int f2=0;
int f3=0;
int f4=0;
int f5=0;
int f6=0;
int f7=0;
int f8=0;
int a[10];
int c[10];
int e[10];
int b[10];
int ef[10];
int d[10];
int ed[10];
int aa[10];
int ca[10];
int ea[10];
int i;
Servo myservo; 
int valservo;
int valservomin=30;
int valservomax=150;
long tservo=millis();
int pinag1=9;
int pinag2=10;
int pinag3=12;
int ac0=0;
int ac1=0;
int ac2=0;
int ac3=0;
int ac4=0;
int rc=0;
int p=0;
long t1=millis();
int comptvit=0;
long t2=millis();
int comptma=0;
int ma1=0;
int mode=0;
int potmode;
int N1=1;
int N2=1;
long previousMillis = 0;  
long interval = 0;   
int retro1;
int retro2;
int retro3;
int retro4;
int n=1;
int j;
byte octet[10]; 
int nombreoctet;
int retroc;
int compteurretro=0;
int fonction;
int  testtrajet0;
int  testtrajet1;
long t0=millis();
int duree;
int ar1;
int ar2;
long fonctions;
int x1;
int x2;
int y1;
int y2;
int adress;
int vit;
int potrc;
int comptrc=0;
long trc=millis();
int compteurmode=5;
int vitmax=9;
int P=0;
int K1;
int K2;
int retro[10];
int Q=0;
int potfonction;
int compteurfonction;
long tfonction=millis();
long tloco1 = millis();  
long tloco2 = millis();  
int ad;
int adressea;
int comservo=0;
int fonctions1;
int fonctions2;
int dvit;
byte groupe=1;
int compteurgroupe=0;
long tgroupe=millis();



void setup()
{
  pinMode(sdcc, OUTPUT);      // sets the digital pin 13 as output
pinMode(pinretro1, INPUT);   
pinMode(pinretro2, INPUT); 
pinMode(pinretro3, INPUT); 
pinMode(pinretro4, INPUT); 
pinMode(pinrc, INPUT); 
pinMode(pinag1, OUTPUT); 
pinMode(pinag2, OUTPUT); 
pinMode(pinag3, OUTPUT); 
myservo.attach(11);
Serial.begin(9600);
Serial1.begin(9600);
Serial2.begin(9600);
lcd.begin(20,4); 
lcd.backlight(); // finish with backlight on 
Serial2.print(groupe);
}

void loop()
{
 
Q=Q+1;
 
 // choix du mode de fonctionnement
  potmode = analogRead(A3);
 if (potmode>935 ) mode=10; //commande manuelle par reconnaissance vocale 
 if (potmode>915 && potmode<935) mode=9; //commande manuelle et automatique avec PC 
 if (potmode>896 && potmode<915) mode=8; //commande automatique sans PC trajet 8  
 if (potmode>875 && potmode<896) mode=7; //commande automatique sans PC trajet 7 
 if (potmode>855 && potmode<875) mode=6; //commande automatique sans PC trajet 6 
 if (potmode>830 && potmode<855) mode=5; //commande automatique sans PC trajet 5 
 if (potmode>790 && potmode<830) mode=4; //commande automatique sans PC trajet 4 
 if (potmode>710 && potmode<790) mode=3; //commande automatique sans PC trajet 3
 if (potmode>650 && potmode<710) mode=2; //commande automatique sans PC trajet 2
 if (potmode>600  && potmode<650) mode=1; //commande automatique sans PC trajet 1
 if (potmode<600) mode=0; //commande manuelle sans PC
 
 if (mode==0 && mode != compteurmode) {
lcd.clear(); 
lcd.setCursor(0, 0);
lcd.print("Mode: ");
lcd.setCursor(9, 0);
lcd.print("manuel");
lcd.setCursor(0, 1);
lcd.print("Adresse: ");
lcd.setCursor(0, 2);
lcd.print("Vitesse: ");
lcd.setCursor(0, 3);
lcd.print("Fonction: ");
 compteurmode=mode;  
 }
 
 
  if (mode==1 && mode != compteurmode) {
lcd.clear(); 
lcd.setCursor(0, 0);
lcd.print("Mode: ");
lcd.setCursor(9, 0);
lcd.print("man + auto1");
lcd.setCursor(0, 1);
lcd.print("N");
lcd.setCursor(5, 1);
lcd.print("A");
lcd.setCursor(9, 1);
lcd.print("V");
lcd.setCursor(14, 1);
lcd.print("T");
lcd.setCursor(0, 2);
lcd.print("N");
lcd.setCursor(5, 2);
lcd.print("A");
lcd.setCursor(9, 2);
lcd.print("V");
lcd.setCursor(14, 2);
lcd.print("T");
lcd.setCursor(0, 3);
lcd.print("MAN");
lcd.setCursor(5, 3);
lcd.print("A");
lcd.setCursor(9, 3);
lcd.print("V");
lcd.setCursor(14, 3);
lcd.print("F");
 compteurmode=mode;  
 }
 
 if (mode==2 && mode != compteurmode) {
lcd.clear(); 
lcd.setCursor(0, 0);
lcd.print("Mode: ");
lcd.setCursor(9, 0);
lcd.print("man + auto2");
lcd.setCursor(0, 1);
lcd.print("N");
lcd.setCursor(5, 1);
lcd.print("A");
lcd.setCursor(9, 1);
lcd.print("V");
lcd.setCursor(14, 1);
lcd.print("T");
lcd.setCursor(0, 2);
lcd.print("N");
lcd.setCursor(5, 2);
lcd.print("A");
lcd.setCursor(9, 2);
lcd.print("V");
lcd.setCursor(14, 2);
lcd.print("T");
lcd.setCursor(0, 3);
lcd.print("MAN");
lcd.setCursor(5, 3);
lcd.print("A");
lcd.setCursor(9, 3);
lcd.print("V");
lcd.setCursor(14, 3);
lcd.print("F");
compteurmode=mode;  
 }
 if (mode==3 && mode != compteurmode) {
lcd.clear(); 
lcd.setCursor(0, 0);
lcd.print("Mode: ");
lcd.setCursor(9, 0);
lcd.print("man + auto3");
lcd.setCursor(0, 1);
lcd.print("N");
lcd.setCursor(5, 1);
lcd.print("A");
lcd.setCursor(9, 1);
lcd.print("V");
lcd.setCursor(14, 1);
lcd.print("T");
lcd.setCursor(0, 2);
lcd.print("N");
lcd.setCursor(5, 2);
lcd.print("A");
lcd.setCursor(9, 2);
lcd.print("V");
lcd.setCursor(14, 2);
lcd.print("T");
lcd.setCursor(0, 3);
lcd.print("MAN");
lcd.setCursor(5, 3);
lcd.print("A");
lcd.setCursor(9, 3);
lcd.print("V");
lcd.setCursor(14, 3);
lcd.print("F");
compteurmode=mode;  
 } 
  if (mode==4 && mode != compteurmode) {
lcd.clear(); 
lcd.setCursor(0, 0);
lcd.print("Mode: ");
lcd.setCursor(9, 0);
lcd.print("man + auto4");
lcd.setCursor(0, 1);
lcd.print("N");
lcd.setCursor(5, 1);
lcd.print("A");
lcd.setCursor(9, 1);
lcd.print("V");
lcd.setCursor(14, 1);
lcd.print("T");
lcd.setCursor(0, 2);
lcd.print("N");
lcd.setCursor(5, 2);
lcd.print("A");
lcd.setCursor(9, 2);
lcd.print("V");
lcd.setCursor(14, 2);
lcd.print("T");
lcd.setCursor(0, 3);
lcd.print("MAN");
lcd.setCursor(5, 3);
lcd.print("A");
lcd.setCursor(9, 3);
lcd.print("V");
lcd.setCursor(14, 3);
lcd.print("F");
compteurmode=mode;  
 } 
if (mode==5 && mode != compteurmode) {
lcd.clear(); 
lcd.setCursor(0, 0);
lcd.print("Mode: ");
lcd.setCursor(9, 0);
lcd.print("man + auto5");
lcd.setCursor(0, 1);
lcd.print("N");
lcd.setCursor(5, 1);
lcd.print("A");
lcd.setCursor(9, 1);
lcd.print("V");
lcd.setCursor(14, 1);
lcd.print("T");
lcd.setCursor(0, 2);
lcd.print("N");
lcd.setCursor(5, 2);
lcd.print("A");
lcd.setCursor(9, 2);
lcd.print("V");
lcd.setCursor(14, 2);
lcd.print("T");
lcd.setCursor(0, 3);
lcd.print("MAN");
lcd.setCursor(5, 3);
lcd.print("A");
lcd.setCursor(9, 3);
lcd.print("V");
lcd.setCursor(14, 3);
lcd.print("F");
compteurmode=mode;  
 } 
 if (mode==6 && mode != compteurmode) {
lcd.clear(); 
lcd.setCursor(0, 0);
lcd.print("Mode: ");
lcd.setCursor(9, 0);
lcd.print("man + auto6");
lcd.setCursor(0, 1);
lcd.print("N");
lcd.setCursor(5, 1);
lcd.print("A");
lcd.setCursor(9, 1);
lcd.print("V");
lcd.setCursor(14, 1);
lcd.print("T");
lcd.setCursor(0, 2);
lcd.print("N");
lcd.setCursor(5, 2);
lcd.print("A");
lcd.setCursor(9, 2);
lcd.print("V");
lcd.setCursor(14, 2);
lcd.print("T");
lcd.setCursor(0, 3);
lcd.print("MAN");
lcd.setCursor(5, 3);
lcd.print("A");
lcd.setCursor(9, 3);
lcd.print("V");
lcd.setCursor(14, 3);
lcd.print("F");
compteurmode=mode;  
 }
if (mode==7 && mode != compteurmode) {
lcd.clear(); 
lcd.setCursor(0, 0);
lcd.print("Mode: ");
lcd.setCursor(9, 0);
lcd.print("man + auto7");
lcd.setCursor(0, 1);
lcd.print("N");
lcd.setCursor(5, 1);
lcd.print("A");
lcd.setCursor(9, 1);
lcd.print("V");
lcd.setCursor(14, 1);
lcd.print("T");
lcd.setCursor(0, 2);
lcd.print("N");
lcd.setCursor(5, 2);
lcd.print("A");
lcd.setCursor(9, 2);
lcd.print("V");
lcd.setCursor(14, 2);
lcd.print("T");
lcd.setCursor(0, 3);
lcd.print("MAN");
lcd.setCursor(5, 3);
lcd.print("A");
lcd.setCursor(9, 3);
lcd.print("V");
lcd.setCursor(14, 3);
lcd.print("F");
compteurmode=mode;  
 }  
 if (mode==8 && mode != compteurmode) {
lcd.clear(); 
lcd.setCursor(0, 0);
lcd.print("Mode: ");
lcd.setCursor(9, 0);
lcd.print("man + auto8");
lcd.setCursor(0, 1);
lcd.print("N");
lcd.setCursor(5, 1);
lcd.print("A");
lcd.setCursor(9, 1);
lcd.print("V");
lcd.setCursor(14, 1);
lcd.print("T");
lcd.setCursor(0, 2);
lcd.print("N");
lcd.setCursor(5, 2);
lcd.print("A");
lcd.setCursor(9, 2);
lcd.print("V");
lcd.setCursor(14, 2);
lcd.print("T");
lcd.setCursor(0, 3);
lcd.print("MAN");
lcd.setCursor(5, 3);
lcd.print("A");
lcd.setCursor(9, 3);
lcd.print("V");
lcd.setCursor(14, 3);
lcd.print("F");
compteurmode=mode;  
 }  
  if (mode==9 && mode != compteurmode) {
lcd.clear(); 
lcd.setCursor(0, 0);
lcd.print("Mode: ");
lcd.setCursor(9, 0);
lcd.print("PC");
compteurmode=mode;  
 } 
 
if (mode==10 && mode != compteurmode) {
lcd.clear(); 
lcd.setCursor(0, 0);
lcd.print("Mode: ");
lcd.setCursor(9, 0);
lcd.print("manuel RV");
lcd.setCursor(0, 1);
lcd.print("Adresse: ");
lcd.setCursor(0, 2);
lcd.print("Vitesse: ");
lcd.setCursor(0, 3);
lcd.print("Fonction: ");
 compteurmode=mode;  
 }
 
 if (mode<9 && Q==1) {


 
// adresse
  potadresse = analogRead(A2);
  adresse = (int)(potadresse/100);
  if (adresse>9) adresse=9;
  
 


a[7]=0;
adress=adresse;
a[6]=(int)(adress/64);
if (a[6]==1) adress=adress-64;
a[5]=(int)(adress/32);
if (a[5]==1) adress=adress-32;
a[4]=(int)(adress/16);
if (a[4]==1) adress=adress-16;
a[3]=(int)(adress/8);
if (a[3]==1) adress=adress-8;
a[2]=(int)(adress/4);
if (a[2]==1) adress=adress-4;
a[1]=(int)(adress/2);
if (a[1]==1) adress=adress-2;
a[0]=(int)(adress);




// vitesse et sens de marche

if (adresse==9) vitmax=4;
if (adresse==8) vitmax=4;
if (adresse==3) vitmax=10;
dvit=(int)(500/vitmax);

rc = digitalRead(pinrc);




// commande par boitier
if (rc==0) {
  potvit = analogRead(A0);
     if (potvit>500) {
   ma=1;
   vitesse=(int)((potvit-500)/dvit);
 }
   if (potvit<500) {
   ma=0;
    vitesse=(int)((500-potvit)/dvit);
   }
if (vitesse==1) vitesse=0;
if (vitesse>9) vitesse=9;

// fonctions F0 à F4
potfonction=analogRead(A4);
if (adresse>2) {
if (compteurfonction==0) {
if (potfonction<100) f0=1-f0;
if (potfonction>100 && potfonction<200) f1=1-f1;
if (potfonction>400 && potfonction<600) f3=1-f3;
if (potfonction>600 && potfonction<800) f4=1-f4;
compteurfonction=1;
tfonction=millis();
}
if (potfonction>200 && potfonction<400){
 f2=1;
}
else
{
f2=0;
}
if (millis()>tfonction+2000) compteurfonction=0;
}

// commande des accessoires par l'adresse 1
if (adresse==1) {
if (compteurfonction==0) {
if (potfonction<100) ac0=1-ac0;
if (potfonction>100 && potfonction<200) ac1=1-ac1;
if (potfonction>200 && potfonction<400) ac2=1-ac2;
if (potfonction>400 && potfonction<600) ac3=1-ac3;
if (potfonction>600 && potfonction<800) ac4=1-ac4;
compteurfonction=1;
tfonction=millis();
} 
if (millis()>tfonction+2000) compteurfonction=0;

}

// commande de la sonorisation du réseau  par l'adresse 2
if (adresse==2) {

if (potfonction<100 && compteurfonction==0)  {
groupe=5;
Serial2.print(groupe);
compteurfonction=1;
tfonction=millis();
}
if (potfonction>100 && potfonction<200 && compteurfonction==0) {
groupe=6;
Serial2.print(groupe);
compteurfonction=1;
tfonction=millis();
}
if (potfonction>200 && potfonction<400 && compteurfonction==0) {
groupe=7;
Serial2.print(groupe);
compteurfonction=1;
tfonction=millis();
}

if (millis()>tfonction+2000)  {
compteurfonction=0;
groupe=1;
Serial2.print(groupe);
tfonction=millis();
}

}


}

// commande par radiocommande
if (rc==1) {
 
// reception des commandes de l'ARDUINO UNO
  i=0;
 n=0;
            while (Serial1.available() > 0)
          {
                  octet[i] = Serial1.read();
                  i++;
                  n=n+1;
               
            } 

if (octet[0]==65) {
ma= octet[3] - 48;
vitesse= octet[6] - 48; 
fonction= octet[9] - 48; 
 }  
f2=(int)(fonction/4);
if (f2==1) fonction=fonction-4;
f1=(int)(fonction/2);
if (f1==1) fonction=fonction-2;
f0=(int)fonction;

}


                 
c[7]=0;
c[6]=1;
c[5]=ma;

if (vitesse>vitmax) vitesse=vitmax;

vit=vitesse;

c[4]=(int)(vit/16);
if (c[4]==1) vit=vit-16;
c[3]=(int)(vit/8);
if (c[3]==1) vit=vit-8;
c[2]=(int)(vit/4);
if (c[2]==1) vit=vit-4;  
c[1]=(int)(vit/2);
if (c[1]==1) vit=vit-2;
c[0]=(int)(vit);




// fonctions
if (adresse>0) {
b[0] = f1;
b[1] = f2;
b[2] = f3;
b[3] = f4;
b[4] = f0;
b[5]=0;
b[6]=0;
b[7]=1;
}

// commande d'accessoires adresse 1
// commande de servo fonction f0
if (adresse==1) {

if (ac0 ==0)  {
if (millis()>tservo + 100) {
valservo=valservo-1;
tservo=millis();
myservo.write(valservo);  
}
}
if (valservo<valservomin) valservo=valservomin ;
if (ac0 ==1) {
if (millis()>tservo + 100) {
valservo=valservo+1;
tservo=millis();
myservo.write(valservo);  
}
}
if (valservo>valservomax) valservo=valservomax ;


// commande AG1 fonction F1

if (ac1 ==0) digitalWrite(pinag1, LOW); 
if (ac1 ==1) digitalWrite(pinag1, HIGH); 

// commande AG2 fonction F2

if (ac2 ==0) digitalWrite(pinag2, LOW); 
if (ac2 ==1) digitalWrite(pinag2, HIGH); 

// commande AG3 fonction F3

if (ac3 ==0) digitalWrite(pinag3, LOW); 
if (ac3 ==1) digitalWrite(pinag3, HIGH); 

}

// transmission des données au PC et à l'afficheur



if (adresse==1) {
 f0 = ac0;
 f4 = ac4;
 f3 = ac3;
 f2 = ac2;
 f1 = ac1;
}


fonction=f0+2*f1+4*f2+8*f3+16*f4;

// retrosignalisation
retro[1] = digitalRead(pinretro1);
retro[2] = digitalRead(pinretro2);
retroc=retro[1]+2*retro[2];

testtrajet1=adresse+ma+vitesse+fonction+retroc;
if ( testtrajet1 != testtrajet0 )  {
interval=(millis()-t0)/1000;
duree = (int) interval;
if (retroc>0) duree = 100 + retroc;
if (duree>0) {
Serial.println(0) ;
Serial.println(adresse) ;
Serial.println(ma) ;
Serial.println(vitesse) ;
Serial.println(fonction) ;
Serial.println(duree) ;

// affichage des commandes

if (rc==0 && mode==0) {
lcd.setCursor(9, 1);
lcd.print(adresse);
lcd.setCursor(9, 2);
if (ma==1) lcd.print("+");
if (ma==0) lcd.print("-");
lcd.setCursor(10, 2);
if (vitesse<10) lcd.print(vitesse);
lcd.setCursor(9, 3);
lcd.print(f0);
lcd.setCursor(10, 3);
lcd.print(f1);
lcd.setCursor(11, 3);
lcd.print(f2);
lcd.setCursor(12, 3);
lcd.print(f3);
lcd.setCursor(13, 3);
lcd.print(f4);
}

if (rc==0 && mode>0) {
lcd.setCursor(7, 3);
lcd.print(adresse);
lcd.setCursor(11, 3);
if (ma==1) lcd.print("+");
if (ma==0) lcd.print("-");
lcd.setCursor(12, 3);
if (vitesse<10) lcd.print(vitesse);
lcd.setCursor(16, 3);
lcd.print(f0);
lcd.setCursor(17, 3);
lcd.print(f1);
lcd.setCursor(18, 3);
lcd.print(f2);
lcd.setCursor(19, 3);
lcd.print(f3);

}

t0=millis();
testtrajet0=testtrajet1;
}
}

if (mode==0) Q=0;
  
 }
  
if (mode==1) {
// mode automatique sans PC trajet 1
 
// description du trajet 1
// loco 1
if (N1==1&& Q==2)
{
adresse=5;
ma=1;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=20;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==2&& Q==2)
{
adresse=1;
ma=1;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==3&& Q==2)
{
adresse=2;
ma=1;
vitesse=0;
f0=1;
f1=0;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==4&& Q==2)
{
adresse=2;
ma=1;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==5&& Q==2)
{
adresse=5;
ma=1;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==6&& Q==2)
{
adresse=5;
ma=1;
vitesse=0;
f0=1;
f1=0;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==7&& Q==2)
{
adresse=5;
ma=1;
vitesse=0;
f0=1;
f1=1;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==8&& Q==2)
{
adresse=5;
ma=0;
vitesse=0;
f0=1;
f1=1;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==9&& Q==2)
{
adresse=5;
ma=0;
vitesse=0;
f0=1;
f1=1;
f2=1;
f3=0;
f4=0;
duree=3;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==10&& Q==2)
{
adresse=5;
ma=0;
vitesse=0;
f0=1;
f1=1;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==11&& Q==2)
{
adresse=5;
ma=0;
vitesse=3;
f0=1;
f1=1;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==12&& Q==2)
{
adresse=5;
ma=0;
vitesse=3;
f0=1;
f1=1;
f2=0;
f3=0;
f4=0;
duree=101;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==13&& Q==2)
{
adresse=5;
ma=0;
vitesse=3;
f0=1;
f1=1;
f2=0;
f3=0;
f4=0;
duree=15;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==14&& Q==2)
{
adresse=5;
ma=0;
vitesse=0;
f0=1;
f1=1;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==15&& Q==2)
{
adresse=5;
ma=1;
vitesse=0;
f0=1;
f1=1;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==16&& Q==2)
{
adresse=1;
ma=1;
vitesse=0;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==17&& Q==2)
{
adresse=5;
ma=1;
vitesse=3;
f0=1;
f1=1;
f2=0;
f3=0;
f4=0;
duree=101;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==18&& Q==2)
{
adresse=5;
ma=1;
vitesse=3;
f0=1;
f1=1;
f2=0;
f3=0;
f4=0;
duree=15;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==19&& Q==2)
{
adresse=5;
ma=1;
vitesse=0;
f0=1;
f1=1;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==20&& Q==2)
{
adresse=5;
ma=1;
vitesse=0;
f0=1;
f1=0;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==21&& Q==2)
{
adresse=5;
ma=1;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==22&& Q==2)
{
adresse=5;
ma=1;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1>22){
N1=1;
}
if (Q>2) Q=0;
// fin de la description du trajet 1

}
// fin du mode automatique sans PC trajet 1 

if (mode==2) {
// mode automatique sans PC trajet 2


 
// description du trajet 2
// loco 1
if (N1==1&& Q==2)
{
adresse=9;
ma=1;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=20;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==2&& Q==2)
{
adresse=1;
ma=1;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==3&& Q==2)
{
adresse=9;
ma=1;
vitesse=0;
f0=1;
f1=0;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==4&& Q==2)
{
adresse=9;
ma=1;
vitesse=0;
f0=1;
f1=1;
f2=0;
f3=0;
f4=0;
duree=20;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==5&& Q==2)
{
adresse=9;
ma=1;
vitesse=0;
f0=1;
f1=1;
f2=0;
f3=0;
f4=1;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==6&& Q==2)
{
adresse=9;
ma=1;
vitesse=0;
f0=1;
f1=1;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==7&& Q==2)
{
adresse=9;
ma=1;
vitesse=4;
f0=1;
f1=1;
f2=0;
f3=0;
f4=0;
duree=101;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==8&& Q==2)
{
adresse=9;
ma=1;
vitesse=4;
f0=1;
f1=1;
f2=0;
f3=0;
f4=0;
duree=20;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==9&& Q==2)
{
adresse=9;
ma=1;
vitesse=0;
f0=1;
f1=1;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==10&& Q==2)
{
adresse=9;
ma=0;
vitesse=0;
f0=1;
f1=1;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==11&& Q==2)
{
adresse=9;
ma=0;
vitesse=4;
f0=1;
f1=1;
f2=0;
f3=0;
f4=0;
duree=101;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==12&& Q==2)
{
adresse=9;
ma=0;
vitesse=4;
f0=1;
f1=1;
f2=0;
f3=0;
f4=0;
duree=20;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==13&& Q==2)
{
adresse=9;
ma=0;
vitesse=0;
f0=1;
f1=1;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==14&& Q==2)
{
adresse=9;
ma=0;
vitesse=0;
f0=1;
f1=0;
f2=0;
f3=0;
f4=0;
duree=20;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==15&& Q==2)
{
adresse=9;
ma=0;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1>15){
N1=1;
}
if (Q>2) Q=0;
// fin de la description du trajet 2



}
// fin du mode automatique sans PC trajet 2 

if (mode==3) {
// mode automatique sans PC trajet 3


 
// description du trajet 3
// loco 1
if (N1==1&& Q==2)
{
adresse=7;
ma=1;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=20;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==2&& Q==2)
{
adresse=7;
ma=1;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=20;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==3&& Q==2)
{
adresse=7;
ma=1;
vitesse=0;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==4&& Q==2)
{
adresse=7;
ma=1;
vitesse=0;
f0=0;
f1=1;
f2=1;
f3=0;
f4=1;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==5&& Q==2)
{
adresse=7;
ma=1;
vitesse=0;
f0=0;
f1=1;
f2=0;
f3=0;
f4=1;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==6&& Q==2)
{
adresse=7;
ma=1;
vitesse=3;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=101;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==7&& Q==2)
{
adresse=7;
ma=1;
vitesse=3;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=10;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==8&& Q==2)
{
adresse=7;
ma=1;
vitesse=0;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==9&& Q==2)
{
adresse=7;
ma=0;
vitesse=0;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==10&& Q==2)
{
adresse=7;
ma=0;
vitesse=3;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=101;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==11&& Q==2)
{
adresse=7;
ma=0;
vitesse=3;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=10;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==12&& Q==2)
{
adresse=7;
ma=0;
vitesse=0;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==13&& Q==2)
{
adresse=7;
ma=0;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==14&& Q==2)
{
adresse=7;
ma=0;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==15&& Q==2)
{
adresse=7;
ma=0;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1>15){
N1=1;
}
if (Q>2) Q=0;
// fin de la description du trajet 3


}
// fin du mode automatique sans PC trajet 3 

if (mode==4) {
// mode automatique sans PC trajet 4


 
// description du trajet 4
// loco 1
if (N1==1&& Q==2)
{
adresse=7;
ma=1;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=20;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==2&& Q==2)
{
adresse=7;
ma=1;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=20;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==3&& Q==2)
{
adresse=7;
ma=1;
vitesse=0;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==4&& Q==2)
{
adresse=7;
ma=1;
vitesse=0;
f0=0;
f1=1;
f2=1;
f3=0;
f4=1;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==5&& Q==2)
{
adresse=7;
ma=1;
vitesse=0;
f0=0;
f1=1;
f2=0;
f3=0;
f4=1;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==6&& Q==2)
{
adresse=7;
ma=1;
vitesse=3;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=101;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==7&& Q==2)
{
adresse=7;
ma=1;
vitesse=3;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=10;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==8&& Q==2)
{
adresse=7;
ma=1;
vitesse=0;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==9&& Q==2)
{
adresse=7;
ma=0;
vitesse=0;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==10&& Q==2)
{
adresse=7;
ma=0;
vitesse=3;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=101;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==11&& Q==2)
{
adresse=7;
ma=0;
vitesse=3;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=10;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==12&& Q==2)
{
adresse=7;
ma=0;
vitesse=0;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==13&& Q==2)
{
adresse=7;
ma=0;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==14&& Q==2)
{
adresse=7;
ma=0;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==15&& Q==2)
{
adresse=7;
ma=0;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1>15){
N1=1;
}
if (Q>2) Q=0;
// fin de la description du trajet 4


}
// fin du mode automatique sans PC trajet 4 

if (mode==5) {
// mode automatique sans PC trajet 5


 
// description du trajet 5
// loco 1
if (N1==1&& Q==2)
{
adresse=7;
ma=1;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=20;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==2&& Q==2)
{
adresse=7;
ma=1;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=20;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==3&& Q==2)
{
adresse=7;
ma=1;
vitesse=0;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==4&& Q==2)
{
adresse=7;
ma=1;
vitesse=0;
f0=0;
f1=1;
f2=1;
f3=0;
f4=1;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==5&& Q==2)
{
adresse=7;
ma=1;
vitesse=0;
f0=0;
f1=1;
f2=0;
f3=0;
f4=1;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==6&& Q==2)
{
adresse=7;
ma=1;
vitesse=3;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=101;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==7&& Q==2)
{
adresse=7;
ma=1;
vitesse=3;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=10;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==8&& Q==2)
{
adresse=7;
ma=1;
vitesse=0;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==9&& Q==2)
{
adresse=7;
ma=0;
vitesse=0;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==10&& Q==2)
{
adresse=7;
ma=0;
vitesse=3;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=101;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==11&& Q==2)
{
adresse=7;
ma=0;
vitesse=3;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=10;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==12&& Q==2)
{
adresse=7;
ma=0;
vitesse=0;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==13&& Q==2)
{
adresse=7;
ma=0;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==14&& Q==2)
{
adresse=7;
ma=0;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==15&& Q==2)
{
adresse=7;
ma=0;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1>15){
N1=1;
}
if (Q>2) Q=0;
// fin de la description du trajet 5


}
// fin du mode automatique sans PC trajet 5 

if (mode==6) {
// mode automatique sans PC trajet 6


 
// description du trajet 6
// loco 1
if (N1==1&& Q==2)
{
adresse=7;
ma=1;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=20;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==2&& Q==2)
{
adresse=7;
ma=1;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=20;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==3&& Q==2)
{
adresse=7;
ma=1;
vitesse=0;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==4&& Q==2)
{
adresse=7;
ma=1;
vitesse=0;
f0=0;
f1=1;
f2=1;
f3=0;
f4=1;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==5&& Q==2)
{
adresse=7;
ma=1;
vitesse=0;
f0=0;
f1=1;
f2=0;
f3=0;
f4=1;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==6&& Q==2)
{
adresse=7;
ma=1;
vitesse=3;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=101;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==7&& Q==2)
{
adresse=7;
ma=1;
vitesse=3;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=10;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==8&& Q==2)
{
adresse=7;
ma=1;
vitesse=0;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==9&& Q==2)
{
adresse=7;
ma=0;
vitesse=0;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==10&& Q==2)
{
adresse=7;
ma=0;
vitesse=3;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=101;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==11&& Q==2)
{
adresse=7;
ma=0;
vitesse=3;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=10;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==12&& Q==2)
{
adresse=7;
ma=0;
vitesse=0;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==13&& Q==2)
{
adresse=7;
ma=0;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==14&& Q==2)
{
adresse=7;
ma=0;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==15&& Q==2)
{
adresse=7;
ma=0;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1>15){
N1=1;
}
if (Q>2) Q=0;
// fin de la description du trajet 6


}
// fin du mode automatique sans PC trajet 6 

if (mode==7) {
// mode automatique sans PC trajet 7


 
// description du trajet 7
// loco 1
if (N1==1&& Q==2)
{
adresse=4;
ma=1;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=20;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==2&& Q==2)
{
adresse=2;
ma=1;
vitesse=0;
f0=1;
f1=0;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==3&& Q==2)
{
adresse=2;
ma=1;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==4&& Q==2)
{
adresse=4;
ma=1;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=10;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==5&& Q==2)
{
adresse=2;
ma=1;
vitesse=0;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==6&& Q==2)
{
adresse=2;
ma=1;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==7&& Q==2)
{
adresse=2;
ma=1;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==8&& Q==2)
{
adresse=2;
ma=1;
vitesse=0;
f0=1;
f1=0;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==9&& Q==2)
{
adresse=2;
ma=1;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==10&& Q==2)
{
adresse=2;
ma=1;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=10;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==11&& Q==2)
{
adresse=2;
ma=1;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=10;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1>11){
N1=1;
}
if (Q>2) Q=0;
// fin de la description du trajet 7


}
// fin du mode automatique sans PC trajet 7 

if (mode==8) {
// mode automatique sans PC trajet 8


 
// description du trajet 8
// loco 1
if (N1==1&& Q==2)
{
adresse=7;
ma=1;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=20;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==2&& Q==2)
{
adresse=7;
ma=1;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=20;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==3&& Q==2)
{
adresse=7;
ma=1;
vitesse=0;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==4&& Q==2)
{
adresse=7;
ma=1;
vitesse=0;
f0=0;
f1=1;
f2=1;
f3=0;
f4=1;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==5&& Q==2)
{
adresse=7;
ma=1;
vitesse=0;
f0=0;
f1=1;
f2=0;
f3=0;
f4=1;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==6&& Q==2)
{
adresse=7;
ma=1;
vitesse=3;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=101;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==7&& Q==2)
{
adresse=7;
ma=1;
vitesse=3;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=10;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==8&& Q==2)
{
adresse=7;
ma=1;
vitesse=0;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==9&& Q==2)
{
adresse=7;
ma=0;
vitesse=0;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==10&& Q==2)
{
adresse=7;
ma=0;
vitesse=3;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=101;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==11&& Q==2)
{
adresse=7;
ma=0;
vitesse=3;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=10;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==12&& Q==2)
{
adresse=7;
ma=0;
vitesse=0;
f0=0;
f1=1;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==13&& Q==2)
{
adresse=7;
ma=0;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==14&& Q==2)
{
adresse=7;
ma=0;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1==15&& Q==2)
{
adresse=7;
ma=0;
vitesse=0;
f0=0;
f1=0;
f2=0;
f3=0;
f4=0;
duree=5;
K1=findeligne1(N1,duree,adresse,ma,vitesse,rc);
N1=N1+K1;
}
if (N1>15){
N1=1;
}
if (Q>2) Q=0;
// fin de la description du trajet 8


}
// fin du mode automatique sans PC trajet 8 




if (mode==9 ) {
// mode manuel et automatique avec PC

// test des detecteurs de retrosignalisation et envoi du signal vers le PC
retro[1] = digitalRead(pinretro1);
retro[2] = digitalRead(pinretro2);
retroc=retro[1]+2*retro[2];

if (retroc>0) {
if (compteurretro==0) {  
Serial.println(retroc);
t0=millis();
compteurretro=1;
}
}
if (millis()>t0+1000) compteurretro=0;



// reception des octets de commande du PC
 i=0;
 n=0;
            while (Serial.available() > 0)
          {
                  octet[i] = Serial.read();
                  i++;
                  n=n+1;
               
            } 


 //adresse entre 1 et 99
 if (octet[0]==65) {
 if (n==4) {  
  adresse= octet[2] - 48;
 

 }
  if (n==5) {  
  adresse= 10*(octet[2] - 48) + octet[3] - 48;
  

 }
 
}
// vitesse MAV entre 0 et 99
 if (octet[0]==62) {
   ma=1;
  if (n==3) {
  vitesse= octet[1] - 48;
  

 }
 if (n==4) {
  vitesse= 10*(octet[1] - 48)+ octet[2] - 48;
  

 }
}

// vitesse MAR entre 0 et 99
 if (octet[0]==60) {
   ma=0;
  if (n==3) {
  vitesse= octet[1] - 48;
  

 }
 if (n==4) {
  vitesse= 10*(octet[1] - 48)+octet[2] - 48;
  

 }
}




// fonctions f0 à f4
 if (octet[0]==79) {

  if (octet[2]<58) y1=octet[2]-48;
 if (octet[2]==65) y1=10;
 if (octet[2]==66) y1=11;
 if (octet[2]==67) y1=12;
 if (octet[2]==68) y1=13;
 if (octet[2]==69) y1=14;
 if (octet[2]==70) y1=15;

 if (octet[3]<58) y2=octet[3]-48;
 if (octet[3]==65) y2=10;
 if (octet[3]==66) y2=11;
 if (octet[3]==67) y2=12;
 if (octet[3]==68) y2=13;
 if (octet[3]==69) y2=14;
 if (octet[3]==70) y2=15;

ad=y1*16+y2;

  if (octet[5]<58) x1=octet[5]-48;
 if (octet[5]==65) x1=10;
 if (octet[5]==66) x1=11;
 if (octet[5]==67) x1=12;
 if (octet[5]==68) x1=13;
 if (octet[5]==69) x1=14;
 if (octet[5]==70) x1=15;

 if (octet[6]<58) x2=octet[6]-48;
 if (octet[6]==65) x2=10;
 if (octet[6]==66) x2=11;
 if (octet[6]==67) x2=12;
 if (octet[6]==68) x2=13;
 if (octet[6]==69) x2=14;
 if (octet[6]==70) x2=15;


if (x1<11  && ad<100) {
fonctions=16*x1+x2-128;
f0=(int)(fonctions/16);
if (f0==1) fonctions=fonctions-16;
f4=(int)(fonctions/8);
if (f4==1) fonctions=fonctions-8;
f3=(int)(fonctions/4);
if (f3==1) fonctions=fonctions-4;
f2=(int)(fonctions/2);
if (f2==1) fonctions=fonctions-2;
f1=(int)fonctions;
}

// fonctions f5 à f8

if (x1==11 && ad<100) {
fonctions=16*x1+x2-176;
f8=(int)(fonctions/8);
if (f8==1) fonctions=fonctions-8;
f7=(int)(fonctions/4);
if (f7==1) fonctions=fonctions-4;
f6=(int)(fonctions/2);
if (f6==1) fonctions=fonctions-2;
f5=(int)fonctions;
} 
// commande d'accessoires d'adresses 2 à 63
if (ad>129) {
adressea=ad-128;
aa[5]=(int)(adressea/32);
if (aa[5]==1) adressea=adressea-32;
aa[4]=(int)(adressea/16);
if (aa[4]==1) adressea=adressea-16;
aa[3]=(int)(adressea/8);
if (aa[3]==1) adressea=adressea-8;
aa[2]=(int)(adressea/4);
if (aa[2]==1) adressea=adressea-4;
aa[1]=(int)(adressea/2);
if (aa[1]==1) adressea=adressea-2;
aa[0]=(int)(adressea);

fonctions=16*x1+x2-248;
ca[2]=(int)(fonctions/4);
if (ca[2]==1) fonctions=fonctions-4;
ca[1]=(int)(fonctions/2);
if (ca[1]==1) fonctions=fonctions-2;
ca[0]=(int)fonctions;
}
// commande d'accessoires d'adresse1
if (ad==129) {
adressea=ad-128;
fonctions=16*x1+x2-248;

 // commande AG1
 if (fonctions==0) digitalWrite(pinag1, LOW); 
 if (fonctions==1) digitalWrite(pinag1, HIGH); 
 // commande AG2
 if (fonctions==2) digitalWrite(pinag2, LOW); 
 if (fonctions==3) digitalWrite(pinag2, HIGH); 
 // commande AG3
 if (fonctions==4) digitalWrite(pinag3, LOW); 
 if (fonctions==5) digitalWrite(pinag3, HIGH); 
 // commande servo 
 if (fonctions==6 ) comservo=1;
 if (fonctions==7 ) comservo=0; 
} 
 } 
 
// mode automatique PC
 if (octet[0]==67) {
     adresse= 10*(octet[1] - 48) + octet[2] - 48;
    if (octet[3]==62) ma=1;
    if (octet[3]==60) ma=0;
vitesse = 10*(octet[4] - 48) + octet[5] - 48;  
fonctions1 = 10*(octet[6] - 48) + octet[7] - 48;
fonctions2 = 10*(octet[8] - 48) + octet[9] - 48;
f4=(int)(fonctions1/16);
if (f4==1) fonctions1=fonctions1-16;
f3=(int)(fonctions1/8);
if (f3==1) fonctions1=fonctions1-8;
f2=(int)(fonctions1/4);
if (f2==1) fonctions1=fonctions1-4;
f1=(int)(fonctions1/2);
if (f1==1) fonctions1=fonctions1-2;
f0=(int)fonctions1; 

f8=(int)(fonctions2/8);
if (f8==1) fonctions2=fonctions2-8;
f7=(int)(fonctions2/4);
if (f7==1) fonctions2=fonctions2-4;
f6=(int)(fonctions2/2);
if (f6==1) fonctions2=fonctions2-2;
f5=(int)fonctions2;   
  
  
 }
 
 

 // commande servo 


 if (comservo==1 && millis()>tservo + 100) {
valservo=valservo-1;
tservo=millis();
myservo.write(valservo);  
}
 
if (valservo<valservomin) valservo=valservomin ; 

 if (comservo==0 && millis()>tservo + 100) {
valservo=valservo+1;
tservo=millis();
myservo.write(valservo);  
}

if (valservo>valservomax) valservo=valservomax ; 
 



}
// fin du mode manuel et automatique avec PC

if (mode==10 ) {
  
// initialisation du groupe 1
potfonction=analogRead(A4);
if (potfonction<100 && compteurgroupe==0)  {
groupe=1;
Serial2.print(groupe);
compteurgroupe=1;
tgroupe=millis();
}



// reception des octets de commande du module de reconnaissance vocale
 i=0;
 n=0;
            while (Serial2.available() > 0)
          {
                  octet[i] = Serial2.read();
                  i++;
                  n=n+1;
               
            } 

 // groupe 1 adresse entre 1 et 9
 if (octet[0]==49 && octet[1]>48) adresse= octet[1] - 48 ;
 
 // quitter le groupe 1 et passer au groupe 2
 if (octet[0]==49 && octet[1]==48) {
 groupe=2;
 Serial2.print(groupe);
compteurgroupe=0;
 }
 
 // groupe 2
  if (octet[0]==50 && octet[1]==48 && compteurgroupe==0) {
  ma=1;
  vitesse=vitesse+1;
  compteurgroupe=1;
  tgroupe=millis();
  }
   if (octet[0]==50 && octet[1]==49 && compteurgroupe==0) {
  ma=1;
  vitesse=vitesse-1;
  compteurgroupe=1;
  tgroupe=millis();
  } 
  
   if (octet[0]==50 && octet[1]==50 && compteurgroupe==0) {
  ma=0;
  vitesse=vitesse+1;
  compteurgroupe=1;
  tgroupe=millis();
  }
   if (octet[0]==50 && octet[1]==51 && compteurgroupe==0) {
  ma=0;
  vitesse=vitesse-1;
  compteurgroupe=1;
  tgroupe=millis();
  } 
  
  if (octet[0]==50 && octet[1]==52 && compteurgroupe==0) {
  vitesse=0;
  compteurgroupe=1;
  tgroupe=millis();
  } 
  
   if (octet[0]==50 && octet[1]==53 && compteurgroupe==0) {
  f0=1-f0;
  compteurgroupe=1;
  tgroupe=millis();
  } 
  
    if (octet[0]==50 && octet[1]==54 && compteurgroupe==0) {
  f1=1-f1;
  compteurgroupe=1;
  tgroupe=millis();
  } 
  
   if (octet[0]==50 && octet[1]==55 && compteurgroupe==0) {
  f2=1;
  compteurgroupe=1;
  tgroupe=millis();
  } 
  
   if (octet[0]==50 && octet[1]==57 && compteurgroupe==0) {
   groupe=1;
 Serial2.print(groupe);
  compteurgroupe=1;
  tgroupe=millis();
  } 
  
  if (millis()>tgroupe+5000)  {
compteurgroupe=0;
f2=0;
}

if (vitesse>5) vitesse=5;
if (vitesse<0) vitesse=0;

// affichage 
testtrajet1=adresse + ma + vitesse + f0 + f1 + f2;
if ( testtrajet1 != testtrajet0 )  {
lcd.setCursor(9, 1);
lcd.print(adresse);
lcd.setCursor(9, 2);
if (ma==1) lcd.print("+");
if (ma==0) lcd.print("-");
lcd.setCursor(10, 2);
if (vitesse<10) lcd.print(vitesse);
lcd.setCursor(9, 3);
lcd.print(f0);
lcd.setCursor(10, 3);
lcd.print(f1);
lcd.setCursor(11, 3);
lcd.print(f2);
testtrajet0=testtrajet1;
}




}
// fin du mode 10


if (mode>0) {
  
  
a[7]=0;
adress=adresse;
a[6]=(int)(adress/64);
if (a[6]==1) adress=adress-64;
a[5]=(int)(adress/32);
if (a[5]==1) adress=adress-32;
a[4]=(int)(adress/16);
if (a[4]==1) adress=adress-16;
a[3]=(int)(adress/8);
if (a[3]==1) adress=adress-8;
a[2]=(int)(adress/4);
if (a[2]==1) adress=adress-4;
a[1]=(int)(adress/2);
if (a[1]==1) adress=adress-2;
a[0]=(int)(adress);
  


// vitesse

c[7]=0;
c[6]=1;
c[5]=ma;

vit=vitesse;

c[4]=(int)(vit/16);
if (c[4]==1) vit=vit-16;
c[3]=(int)(vit/8);
if (c[3]==1) vit=vit-8;
c[2]=(int)(vit/4);
if (c[2]==1) vit=vit-4;  
c[1]=(int)(vit/2);
if (c[1]==1) vit=vit-2;
c[0]=(int)(vit);



// fonctions
if (adresse>2) {
b[0] = f1;
b[1] = f2;
b[2] = f3;
b[3] = f4;
b[4] = f0;
b[5]=0;
b[6]=0;
b[7]=1;
}

// commande d'accessoires adresse 1
// commande de servo fonction f0
if (adresse==1 && mode<9) {
ac0 = f0; 
if (ac0 ==0)  {
if (millis()>tservo + 100) {
valservo=valservo-1;
tservo=millis();
myservo.write(valservo);  
}
}
if (valservo<valservomin) valservo=valservomin ;
if (ac0 ==1) {
if (millis()>tservo + 100) {
valservo=valservo+1;
tservo=millis();
myservo.write(valservo);  
}
}
if (valservo>valservomax) valservo=valservomax ;


// commande AG1 fonction F1
ac1 = f1;
if (ac1 ==0) digitalWrite(pinag1, LOW); 
if (ac1 ==1) digitalWrite(pinag1, HIGH); 

// commande AG2 fonction F2
ac2 = f2;
if (ac2 ==0) digitalWrite(pinag2, LOW); 
if (ac2 ==1) digitalWrite(pinag2, HIGH); 

// commande AG3 fonction F3
ac3 = f3;
if (ac3 ==0) digitalWrite(pinag3, LOW); 
if (ac3 ==1) digitalWrite(pinag3, HIGH); 

 }
 
 // commande de la sonorisation du réseau  par l'adresse 2
if (adresse==2 && mode<9) {
if (f0==1 && compteurgroupe==0)  {
groupe=5;
Serial2.print(groupe);
compteurgroupe=1;
tgroupe=millis();
}

if (f1==1 && compteurgroupe==0)  {
groupe=6;
Serial2.print(groupe);
compteurgroupe=1;
tgroupe=millis();
}

if (f2==1 && compteurgroupe==0)  {
groupe=7;
Serial2.print(groupe);
compteurgroupe=1;
tgroupe=millis();
}
if (millis()>tgroupe+2000)  {
compteurgroupe=0;
groupe=1;
Serial2.print(groupe);
tgroupe=millis();
}


 }
 
 
}

// fonctions du groupe 2
d[0] = f5;
d[1] = f6;
d[2] = f7;
d[3] = f8;
d[4] = 1;
d[5]=1;
d[6]=0;
d[7]=1;

// génération des paquets DCC

// paquet de commande de vitesse
// entete du paquet
 for ( i=0; i <= 15; i++){
  bitun();    
  } 
 bitzero(); 

// octet d'adresse 

 for (i=7; i >=0; i=i-1){
if (a[i]==1) bitun();  
if (a[i]==0) bitzero(); 
  } 
  
  

// bit à zéro
bitzero(); 

// octet de commande

 for (i=7; i >=0; i=i-1){
if (c[i]==1) bitun();  
if (c[i]==0) bitzero(); 
  } 
  


// bit à zéro
bitzero(); 

// octet de controle

for (i=0; i <=7; i=i+1){
e[i] = a[i] ^ c[i];  
}

for (i=7; i >=0; i=i-1){
if (e[i]==1) bitun();  
if (e[i]==0) bitzero(); 
  } 



// bit à un
bitun();   

// pause émission de 25 zéros
 for ( i=0; i <= 25; i++){
bitzero();  
  } 

// paquet de commande de fonctions du groupe 1
// entete du paquet
 for (int i=0; i <= 15; i++){
  bitun();    
  } 
 bitzero(); 

// octet d'adresse 
 for (i=7; i >=0; i=i-1){
if (a[i]==1) bitun();  
if (a[i]==0) bitzero(); 
  } 

// bit à zéro
bitzero();  

// octet de commande

 for (i=7; i >=0; i=i-1){
if (b[i]==1) bitun();  
if (b[i]==0) bitzero(); 
  } 


// bit à zéro
bitzero(); 

// octet de controle

for (i=0; i <=7; i=i+1){
ef[i] = a[i] ^ b[i];  
}

for (i=7; i >=0; i=i-1){
if (ef[i]==1) bitun();  
if (ef[i]==0) bitzero(); 
  } 



// bit à un
bitun();  

// pause émission de 25 zéros
 for ( i=0; i <= 25; i++){
bitzero(); 
  } 

// paquet de commande de fonctions du groupe 2
// entete du paquet
 for (int i=0; i <= 15; i++){
  bitun();    
  } 
 bitzero(); 

// octet d'adresse 
 for (i=7; i >=0; i=i-1){
if (a[i]==1) bitun();  
if (a[i]==0) bitzero(); 
  } 

// bit à zéro
bitzero();  

// octet de commande

 for (i=7; i >=0; i=i-1){
if (d[i]==1) bitun();  
if (d[i]==0) bitzero(); 
  } 


// bit à zéro
bitzero(); 

// octet de controle

for (i=0; i <=7; i=i+1){
ed[i] = a[i] ^ d[i];  
}

for (i=7; i >=0; i=i-1){
if (ed[i]==1) bitun();  
if (ed[i]==0) bitzero(); 
  } 



// bit à un
bitun();  

// pause émission de 25 zéros
 for ( i=0; i <= 25; i++){
bitzero(); 
  } 
  
// paquet de commande d'accessoires
aa[7]=1;
aa[6]=0;
ca[7]=1;
ca[6]=1;
ca[5]=1;
ca[4]=1;
ca[3]=1;
// entete du paquet
 for (int i=0; i <= 15; i++){
  bitun();    
  } 
 bitzero(); 

// octet d'adresse 
 for (i=7; i >=0; i=i-1){
if (aa[i]==1) bitun();  
if (aa[i]==0) bitzero(); 
  } 

// bit à zéro
bitzero();  

// octet de commande

 for (i=7; i >=0; i=i-1){
if (ca[i]==1) bitun();  
if (ca[i]==0) bitzero(); 
  } 


// bit à zéro
bitzero(); 

// octet de controle

for (i=0; i <=7; i=i+1){
ea[i] = aa[i] ^ ca[i];  
}

for (i=7; i >=0; i=i-1){
if (ed[i]==1) bitun();  
if (ed[i]==0) bitzero(); 
  } 



// bit à un
bitun();  

// pause émission de 25 zéros
 for ( i=0; i <= 25; i++){
bitzero(); 
  } 
    
}

void bitun(){    //genere un bit à 1
digitalWrite(sdcc, LOW);   // sets the pin off
delayMicroseconds(58);        // pauses for 58 microseconds      
digitalWrite(sdcc, HIGH);    // sets the pin on
delayMicroseconds(58);        // pauses for 58 microseconds  
}

void bitzero(){    //genere un bit à 0
digitalWrite(sdcc, LOW);   // sets the pin off
delayMicroseconds(116);        // pauses for 116 microseconds      
digitalWrite(sdcc, HIGH);    // sets the pin on
delayMicroseconds(116);        // pauses for 116 microsec
}  


int findeligne1(int N1, int duree,int adresse, int ma ,int vitesse,int rc) {
K1=0;
// affichage
if (P==0 && rc==0) {
lcd.setCursor(2, 1);
int ND=(int)(N1/10);
lcd.print(ND);
lcd.setCursor(3, 1);
int NU=N1-10*ND;
lcd.print(NU);
lcd.setCursor(7, 1);
lcd.print(adresse);
lcd.setCursor(11, 1);
if (ma==1) lcd.print("+");
if (ma==0) lcd.print("-");
lcd.setCursor(12, 1);
lcd.print(vitesse);
lcd.setCursor(16, 1);
int dureec=(int)(duree/100);
lcd.print(dureec);
lcd.setCursor(17, 1);
int dureed=(int)((duree-100*dureec)/10);
lcd.print(dureed);
lcd.setCursor(18, 1);
int dureeu=duree-100*dureec-10*dureed;
lcd.print(dureeu);

P=1;
}
// detection de fin de ligne de commande
if (duree<100) {
 interval=1000*duree;
 if(millis() >tloco1+ interval) {
K1=1;
P=0;
tloco1 = millis();  
}
}
// détection de passage
retro[1] = digitalRead(pinretro1);
retro[2] = digitalRead(pinretro2);
retro[3] = digitalRead(pinretro3);
retro[4] = digitalRead(pinretro4);
for ( i=1; i <=2; i++){
if (duree>100 && i== duree-100 && retro[i] == 1) {
K1=1;
P=0;
tloco1 = millis(); 
 }
}
return K1;
}

int findeligne2(int N2, int duree,int adresse, int ma ,int vitesse,int rc) {
K2=0;
// affichage
if (P==0 && rc==0) {
lcd.setCursor(2, 2);
int ND2=(int)(N2/10);
lcd.print(ND2);
lcd.setCursor(3, 2);
int NU2=N2-10*ND2;
lcd.print(NU2);
lcd.setCursor(7, 2);
lcd.print(adresse);
lcd.setCursor(11, 2);
if (ma==1) lcd.print("+");
if (ma==0) lcd.print("-");
lcd.setCursor(12, 2);
lcd.print(vitesse);
lcd.setCursor(16, 2);
int dureec=(int)(duree/100);
lcd.print(dureec);
lcd.setCursor(17, 2);
int dureed=(int)((duree-100*dureec)/10);
lcd.print(dureed);
lcd.setCursor(18, 2);
int dureeu=duree-100*dureec-10*dureed;
lcd.print(dureeu);
P=1;
}
// detection de fin de ligne de commande
if (duree<100) {
 interval=1000*duree;
 if(millis() >tloco2+ interval) {
K2=1;
P=0;
tloco2 = millis();  
}
}
// détection de passage
retro[1] = digitalRead(pinretro1);
retro[2] = digitalRead(pinretro2);
retro[3] = digitalRead(pinretro3);
retro[4] = digitalRead(pinretro4);
for ( i=1; i <=2; i++){
if (duree>100 && i== duree-100 && retro[i] == 1) {
K2=1;
P=0;
tloco2 = millis(); 
 }
}
return K2;
}


